class ExtendedLogger
  Message = Struct.new :block, :level, :time, :label do
    attr_writer :prose

    def inspect
      "#<ExtendedLogger::Message prose=#{prose.inspect}, level=#{level}, time=#{time.iso8601}, label=#{label.inspect}>"
    end

    def prose
      @prose ||= block.()
    end
  end
end
